svc-zones revision 3c7284bd3243d42a710edac3a15f6019b4c849be
#!/sbin/sh
#
# CDDL HEADER START
#
# The contents of this file are subject to the terms of the
# Common Development and Distribution License (the "License").
# You may not use this file except in compliance with the License.
#
# You can obtain a copy of the license at usr/src/OPENSOLARIS.LICENSE
# or http://www.opensolaris.org/os/licensing.
# See the License for the specific language governing permissions
# and limitations under the License.
#
# When distributing Covered Code, include this CDDL HEADER in each
# file and include the License file at usr/src/OPENSOLARIS.LICENSE.
# If applicable, add the following below this CDDL HEADER, with the
# fields enclosed by brackets "[]" replaced with your own identifying
# information: Portions Copyright [yyyy] [name of copyright owner]
#
# CDDL HEADER END
#
#
# Copyright (c) 2004, 2010, Oracle and/or its affiliates. All rights reserved.
# Copyright 2014 Nexenta Systems, Inc. All rights reserved.
. /lib/svc/share/smf_include.sh
#
# Return a list of running, non-global zones for which a shutdown via
# "/sbin/init 0" may work (typically only Solaris zones.)
#
shutdown_zones()
{
zoneadm list -p | nawk -F: '{
if ($2 != "global") {
print $2
}
}'
}
[ ! -x /usr/sbin/zoneadm ] && exit 0 # SUNWzoneu not installed
if [ -z "$SMF_FMRI" ]; then
echo "this script can only be invoked by smf(5)"
exit $SMF_EXIT_ERR_NOSMF
fi
# Make sure working directory is / to prevent unmounting problems.
cd /
PATH=/usr/sbin:/usr/bin; export PATH
case "$1" in
'start')
egrep -vs '^#|^global:' /etc/zones/index || exit 0 # no local zones
#
# Boot the installed zones for which the "autoboot" zone property is
# set and invoke the sysboot hook for all other installed zones.
#
ZONES=""
for zone in `zoneadm list -pi | nawk -F: '{
if ($3 == "installed") {
print $2
}
}'`; do
zonecfg -z $zone info autoboot | grep "true" >/dev/null 2>&1
if [ $? -eq 0 ]; then
[ -z "$ZONES" ] && echo "Booting zones:\c"
ZONES=yes
echo " $zone\c"
#
# zoneadmd puts itself into its own contract so
# this service will lose sight of it. We don't
# support restart so it is OK for zoneadmd to
# to be in an orphaned contract.
#
zoneadm -z $zone boot &
else
zoneadm -z $zone sysboot &
fi
done
#
# Wait for all zoneadm processes to finish before allowing the
# start method to exit.
#
wait
[ -n "$ZONES" ] && echo .
;;
'stop')
egrep -vs '^#|^global:' /etc/zones/index || exit 0 # no local zones
[ "`zoneadm list`" = "global" ] && exit 0 # no zones running
SVC_TIMEOUT=`svcprop -p stop/timeout_seconds $SMF_FMRI`
#
# First, try shutting down any running zones for which an "init 0" may
# work.
#
MAXSHUT=`expr 3 \* $SVC_TIMEOUT \/ 4` # 3/4 of time to zone shutdown
MAXHALT=`expr $SVC_TIMEOUT \/ 4` # rest of time goes to halt
zonelist=`shutdown_zones`
if [ -n "$zonelist" ]; then
SHUTDOWN=0
echo "Shutting down running zones (for up to $MAXSHUT" \
"seconds):\c"
for zone in $zonelist; do
echo " $zone\c"
zoneadm -z $zone shutdown &
SHUTDOWN=1
done
[ $SHUTDOWN -eq 1 ] && echo "."
# Allow time for zones to shutdown cleanly
while [ $MAXSHUT -gt 0 -a "`shutdown_zones`" != "" ]; do
MAXSHUT=`expr $MAXSHUT - 1`
sleep 1 # wait a bit longer
done
fi
#
# Second, try halting any non-global zones still running
#
WAITPIDS=""
for zone in `zoneadm list`; do
if [ "$zone" != "global" ]; then
[ -z "$WAITPIDS" ] &&
echo "Zones failed to shutdown; trying to halt " \
"(for up to $MAXHALT seconds):\c"
echo " $zone\c"
zoneadm -z $zone halt &
WAITPIDS="$WAITPIDS $!"
fi
done
[ ! -z "$WAITPIDS" ] && echo .
# Wait for the 'zoneadm halt' commands to complete. We will let this
# run forever, since the restart daemon will eventually kill us off
# anyway if the halts do not complete after a certain period of time.
wait $WAITPIDS
# If the halts complete but a zone is still not shutdown, it might
# be in a state like 'shutting_down' or 'down'. So we give it some
# time to come all the way down.
while [ $MAXHALT -gt 0 -a "`zoneadm list`" != "global" ]; do
MAXHALT=`expr $MAXHALT - 1`
sleep 1 # wait a bit longer
done
# If there are any remaining file systems in zones, try to unmount them.
umountall -Z
#
# Report on zones which failed to shutdown.
#
for zone in `zoneadm list`; do
if [ "$zone" != "global" ]; then
echo "Zone '$zone' failed to halt."
fi
done
[ "`zoneadm list`" != "global" ] && exit 1 # zones still running
;;
*)
echo "Usage: $0 { start | stop }"
exit 1
;;
esac
exit 0